  <mgl-map
  id="map"
    [style]="style"
    [zoom]= map_config.zoom
    [center]= map_config.center
    (load)="onLoadMap($event)"
  >

     <!-- Line Jams -->
     <ng-container>

       <!-- <mgl-layer class="off"
       id="jamLine"
       type="line"
       [source]="{
         'type': 'geojson',
         'data': data_source
       }"
       [paint]="{
         'line-width': 3,
         'line-color': ['get', 'color']
       }"
     ></mgl-layer> -->
     <mgl-popup [lngLat]="pointClick" [closeOnClick] = "true" [closeButton] = "false">
       <table width="100%">
         <tr>
           <th style="padding:3px;">Level</th>
           <td style="padding:3px;">:</td>
           <td style="padding:3px;color:#008C50;">{{ jamLevel}}</td>
         </tr>
         <tr>
           <th style="padding:3px;">Road Type</th>
           <td style="padding:3px;">:</td>
           <td style="padding:3px;color:#008C50;">{{ jamRoadType }}</td>
         </tr>
         <tr>
           <th style="padding:3px;">SpeedKMH</th>
           <td style="padding:3px;">:</td>
           <td style="padding:3px;color:#008C50;">{{ jamSpeedKMH}}</td>
         </tr>
         <tr>
           <th style="padding:3px;">Street</th>
           <td style="padding:3px;">:</td>
           <td style="padding:3px;color:#008C50;">{{ jamStreet }}</td>
         </tr>
       </table>
     </mgl-popup>

    </ng-container>


    <!-- Area Jabar -->
     <mgl-layer
      id="citiArea{{ row.properties.kemendagri_kode }}"
     *ngFor="let row of cities;"
      type="fill"
      [source]="{
        'type': 'geojson',
        'data': {
            'type': 'Feature',
            'properties': row.properties,
            'geometry': row.geometry
        }
      }"
      [paint]="{
        'fill-color': 'green',
        'fill-opacity': 0
      }"
    ></mgl-layer>

    <!-- Line Jabar -->
    <mgl-layer
      id="citiLine{{ row.properties.kemendagri_kode }}"
      type="line" *ngFor="let row of cities;"
      [source]="{
        'type': 'geojson',
        'data': {
            'type': 'Feature',
            'properties': row.properties,
            'geometry': row.geometry
        }
      }"
      [paint]="{
        'line-color': '#b37700',
        'line-width': 1.2
      }"
    ></mgl-layer>

    <!-- Choosed City -->
     <!-- <mgl-layer
      id="choosedCityArea{{ row.properties.kemendagri_kode }}"
     *ngFor="let row of choosedCities"
      type="fill"
      [source]="{
        'type': 'geojson',
        'data': {
            'type': 'Feature',
            'properties': row.properties,
            'geometry': row.geometry
        }
      }"
      [paint]="{
        'fill-color': '#66ffff',
        'fill-opacity': 0.2,
        'fill-outline-color': '#000'
      }"
    ></mgl-layer> -->


    <!-- Marker -->

     <ng-container *ngFor="let row of alerts;let i = index">
        <mgl-marker #markerAlert [lngLat]="row.location">
            <div
                class="marker"
                [ngStyle]="{'background-image': 'url(assets/images/'+row.icon+')','width': '67px','height': '80px','background-repeat': 'no-repeat'}"
            >
            </div>
        </mgl-marker>

        <mgl-popup [marker]="markerAlert" [closeButton] = "false">
          <table width="100%">
            <tr>
              <th style="padding:3px;">Road Type</th>
              <td style="padding:3px;">:</td>
              <td style="padding:3px;color:#008C50;">{{ row.roadType}}</td>
            </tr>
            <tr>
              <th style="padding:3px;">Type</th>
              <td style="padding:3px;">:</td>
              <td style="padding:3px;color:#008C50;">{{ row.type}}</td>
            </tr>
            <tr>
              <th style="padding:3px;">Sub Type</th>
              <td style="padding:3px;">:</td>
              <td style="padding:3px;color:#008C50;">{{ row.subType}}</td>
            </tr>
            <tr>
              <th style="padding:3px;">Reliabilty</th>
              <td style="padding:3px;">:</td>
              <td style="padding:3px;color:#008C50;">{{ row.reliability }}</td>
            </tr>
            <tr>
              <th style="padding:3px;">Report Rating</th>
              <td style="padding:3px;">:</td>
              <td style="padding:3px;color:#008C50;">{{ row.reportRating }}</td>
            </tr>
            <tr>
              <th style="padding:3px;">Waktu</th>
              <td style="padding:3px;">:</td>
              <td style="padding:3px;color:#008C50;">{{ row.waktu}}</td>
            </tr>

          </table>
        </mgl-popup>
    </ng-container>


    <!-- Marker radius -->
    <mgl-marker [lngLat]="[107.608137, -6.916395]" (dragEnd) = "onDraggablePointRadius($event)" [draggable] = "true" *ngIf ="isRadius">
    </mgl-marker>

    <!-- control map -->
    <mgl-control
        mglNavigation position="top-right"
    >
    </mgl-control>
  </mgl-map>

  <div class="basemap-opt">
    <span style="float:right">
      <button class="btn-basemap" (click) = toggleDisplayBasemap()><i class="fas fa-map"></i></button>
    </span>
    <span style="float:right" *ngIf ="!isShowToggleBasemap">
      <select [ngModel]="layerId" (ngModelChange)="changeStyle($event)">
        <option value="basic">basic</option>
        <option value="streets">streets</option>
        <option value="bright">bright</option>
        <option value="light">light</option>
        <option value="dark">dark</option>
        <option value="satellite">satellite</option>
      </select>
    </span>
  </div>

  <a href="#0" id="btnFilter" class="cd-btn js-cd-panel-trigger" data-panel="main"><i class="fas fa-bars"></i></a>
  <div class="cd-panel cd-panel--from-left js-cd-panel-main">

      <header class="cd-panel__header">
      <h1>Filter</h1>
      <a href="#0" class="cd-panel__close js-cd-close">Close</a>
      </header>

      <div class="cd-panel__container">
      <div class="cd-panel__content">
          <form>
            <label>Kota/Kabupaten</label>
            <mat-form-field  appearance="outline" style="width:100%;">
              <mat-select placeholder="Kota/Kabupaten" [formControl]="formControl" multiple [(ngModel)]="inp_kota" >
                <mat-option *ngFor="let row of citiesName;" [value]="row.item_id" >{{row.item_text}}</mat-option>
              </mat-select>
            </mat-form-field>

            <div style="height:auto;margin-top:10px;margin-bottom:20px;">
              <div style="width:47%;float:left;margin-right:10px;margin-bottom:10px;">
                <label>
                    Start Date: <br>
                    <input [owlDateTimeTrigger]="dt" [(ngModel)]="defaultDateSt" name="dateFirst" (dateTimeChange) = "changeDate('first', $event)" style="width:90%;padding: 14px 10px; line-height: 6px;font-size:14px;border: none;border:solid 1px #ccc;border-radius: 4px;" [owlDateTime]="dt">
                    <owl-date-time #dt></owl-date-time>
                </label>
              </div>
              <div style="width:47%;float:left;margin-left:10px; margin-bottom:10px;">
                <label>
                    End Date: <br>
                    <input [owlDateTimeTrigger]="dt2" [(ngModel)]="defaultDateNd" name="dateLast" (dateTimeChange) = "changeDate('last', $event)" style="width:90%;padding: 14px 10px; line-height: 6px;font-size:14px;border: none;border:solid 1px #ccc;border-radius: 4px;" [owlDateTime]="dt2">
                    <owl-date-time #dt2></owl-date-time>
                </label>
              </div>
              <div style="clear: both;"></div>

            </div>
            <label>Radius</label><br />
            <div style="padding-left: 1em;padding-top:0.8em;" id="slider-1">
              <mat-checkbox [checked]="isRadius" (change)="toggleRadius($event)"><span style="font-size:12px;font-style:italic">geser icon
                  <img src="assets/images/marker.jpg" width="10px" height="14px" >

                untuk menentukan titik radius </span></mat-checkbox><br>
              <mat-slider
                thumbLabel
                [displayWith]="formatLabelRadius"
                style="width:90%"
                tickInterval="100"
                min="1"
                max="100" (change) = "changeRadius($event)"></mat-slider>
              KM
            </div>



            <label>Type</label><br />

            <div style="padding-left: 1em;padding-top:0.8em;">
              <mat-checkbox [checked]="isAlert"  (change)="toggleFilterType($event, 'alert')">Alert</mat-checkbox><br>
              <mat-checkbox [checked]="isIrregularity"  (change)="toggleFilterType($event, 'irregularities')">Irregularities</mat-checkbox><br>
              <mat-checkbox [checked]="isJam" (change)="toggleFilterType($event, 'jam')">Jam</mat-checkbox>
            </div>

            <input type="button" class="submit" value="Submit" (click)="onSubmit()" >
          </form>
      </div>
      </div>
  </div>

  <div class="legend-jams" *ngIf="isJam || isIrregularity || isAlert">
    <div style="margin-bottom:10px;" *ngIf="isJam || isIrregularity">
      <div>
        Jam Level
      </div>
      <span class="legend-jam-section">
        <span style="margin-right: 0.3em;">Lancar </span>
        <div class="legend-jam-box" *ngFor="let row of jamLevelColor" [ngStyle]="{'background-color':row}"></div>
        <span style="margin-left: 0.3em;">Macet </span>
      </span>

    </div>
    <div *ngIf="isAlert || isIrregularity">
      <div>
        Alert
      </div>
      <div style="display: inline-block;">
        <img src="assets/images/accident.png" width="50px" height="50px" style="float:left;margin-right:20px;vertical-align:middle;">
        <span style=" height: 40px;display: table-cell;vertical-align: middle;">
          Accident
        </span>
      </div>
      <div style="display: inline-block;">
        <img src="assets/images/hazard.png" width="50px" height="50px" style="float:left;margin-right:20px;vertical-align:middle;">
        <span style=" height: 40px;display: table-cell;vertical-align: middle;">
          Weatherhazard / Hazard
        </span>
      </div>
      <div style="display: inline-block;">
        <img src="assets/images/construction.png" width="50px" height="50px" style="float:left;margin-right:20px;vertical-align:middle;">
        <span style=" height: 40px;display: table-cell;vertical-align: middle;">
          Construction
        </span>
      </div>
      <div style="display: inline-block;">
        <img src="assets/images/road-closed.png" width="50px" height="50px" style="float:left;margin-right:20px;vertical-align:middle;">
        <span style=" height: 40px;display: table-cell;vertical-align: middle;">
          Road Closed
        </span>
      </div>
      <div style="display: inline-block;">
        <img src="assets/images/jam-heavy.png" width="50px" height="50px" style="float:left;margin-right:20px;vertical-align:middle;">
        <span style=" height: 40px;display: table-cell;vertical-align: middle;">
          Jam
        </span>
      </div>

    </div>

  </div>

  <div class="widget-time-slider">
      Time slider <span style="font-style:italic;color:#64788c;">( {{timeslideDate}} ) </span>
     <br>

     <!-- thumbLabel -->
     <mat-slider
       [displayWith]="formatLabelRadius"
       style="width:90%"
       tickInterval="1"
       min="0"
       max="{{timeslideMinuteMax}}"
       (change) = "onChangeTimeSlider($event)"
       ></mat-slider>
  </div>

  <ngx-loading [show]="loading" [config]="{ backdropBorderRadius: '3px' }" [template]="customLoadingTemplate"></ngx-loading>
